<?
  # Cration de miniatures JPEG ( partir d'une ide trouve sur www.lephpfacile.com)
  # 3 paramtres  passer en entre :
  #   photo : nom du fichier image, doit contenir une image JPEG ou PNG
  #   dir : chemin d'accs  partir du rpertoire du script et termin par / - Exemple : ./photos/
  #   ratio : petit cot de la vignette en pixels
  $variables = array("photo", "dir", "ratio");
  foreach($_REQUEST as $key => $val) if (in_array($key, $variables)) ${$key} = $val;
  if (! isset($photo)) {
    exit();
  } else {
    # On rcupre les infos de cette image
    $tableau = @getimagesize($dir . $photo);
    // si il ne s'agit pas d'un fichier image, on arrte tout
    if ($tableau == FALSE) {
        exit();
    } else {
      # On ne connait que les types 2 (jpeg) et 3 (png)
      if ($tableau[2] < 2 || $tableau[2] > 3) {
        exit();
      } else {
        # On cre une image  partir de notre grande image  l'aide de la librairie GD
        $src = ($tableau[2] == 2) ? imagecreatefromjpeg($dir . $photo) : imagecreatefrompng($dir . $photo);
        # On teste si notre image est de type paysage ou portrait
        if ($tableau[0] > $tableau[1]) {   # Paysage
          $vignette = imagecreatetruecolor(round(($ratio / $tableau[1]) * $tableau[0]), $ratio);
          imagecopyresampled($vignette, $src, 0, 0, 0, 0, round(($ratio / $tableau[1]) * $tableau[0]), $ratio, $tableau[0], $tableau[1]);
        } else {   # Portrait
          $vignette = imagecreatetruecolor($ratio, round(($ratio / $tableau[0]) * $tableau[1]));
          imagecopyresampled($vignette, $src, 0, 0, 0, 0, $ratio, round($tableau[1] * ($ratio/$tableau[0])), $tableau[0], $tableau[1]);
        }
        header("Content-type: image/jpeg");
        imagejpeg($vignette);
      }
    }
  }
?>
